;
; SIDE-.
;
; (c) Indy, 2013.
;
	.686
	.model flat, stdcall
	option casemap :none

	include \masm32\include\ntdll.inc
	includelib \masm32\lib\ntdll.lib
	
	includelib \masm32\lib\masm32.lib

OPT_ENABLE_DBG_LOG	equ TRUE
OPT_ENABLE_SEP		equ TRUE
OPT_ENABLE_TF		equ TRUE
OPT_ENABLE_DBG		equ TRUE
;OPT_ENABLE_PRINT	equ TRUE
OPT_ENABLE_USER	equ TRUE

ifdef OPT_ENABLE_USER
	include \masm32\include\kernel32.inc
	includelib \masm32\lib\kernel32.lib

	include \masm32\include\user32.inc
	includelib \masm32\lib\user32.lib
endif

.code
	include Tls.asm
	include Snap.asm
	
$Olly	CHAR "OllyDbg.exe", 0

$Log		CHAR "\??\D:\Log.txt", 0

EOL	equ NULL
CRLF	equ <13, 10, EOL>

%DBG macro Msg$, ArgList:VARARG
Local S$
	ifdef OPT_ENABLE_DBG_LOG
		pushfd
		pushad
		Args = 1
		For Arg, <ArgList>
			Args = Args + 1
			push Arg
		Endm
	.data
		S$ CHAR Msg$, CRLF
	.code
		push offset S$
		Call DbgPrint
		add esp,Args * 4
		popad
		popfd
	endif
endm
	
	include Img.asm
	
NTID struct
	Rva		PVOID ?	; RVA .
	Id		ULONG ?	; ID .
	S1ze		ULONG ?	;  .
	Hash		ULONG ?	;   .
	Nam3		CHAR 1 DUP (?)
NTID ends
PNTID typedef ptr NTID

.data
PUBLIC g_Init
PUBLIC g_NtBase
PUBLIC g_NtView
PUBLIC g_NtList
PUBLIC g_NtListN
PUBLIC g_SEP

align 4

g_Init			BOOLEAN FALSE
g_NtBase			PVOID ?	;  ntdll.
g_NtView			PVOID ?	;      ntdll.
g_NtList			PNTID ?	;  . 
g_NtListN			ULONG ?	;  .
g_SEP			BOOLEAN FALSE	;   .
g_TSC			LARGE_INTEGER <>	; Perf. counter.
g_File			HANDLE ?
g_S_FindWindowA	PVOID ?	;   FindWindowA().
g_S_FindWindowW	PVOID ?	;   FindWindowW().

.code
	assume fs:nothing
%GET_NT_BASE macro Reg32
	mov Reg32,fs:[TEB.Peb]
	mov Reg32,PEB.Ldr[Reg32]
	mov Reg32,PEB_LDR_DATA.InLoadOrderModuleList.Flink[Reg32]
	mov Reg32,LDR_DATA_TABLE_ENTRY.InLoadOrderModuleList.Flink[Reg32]
	mov Reg32,LDR_DATA_TABLE_ENTRY.DllBase[Reg32]	; ntdll.dll
endm

; +
;   ntdll.
;
LdrGetNtBase proc C
	%GET_NT_BASE Eax
	ret
LdrGetNtBase endp

PARSEINFO struct
S1ze		ULONG ?
N		ULONG ?
PARSEINFO ends
PPARSEINFO typedef ptr PARSEINFO

; +
;
;      .
;
ZwParseCallbackI proc Info:PPARSEINFO, $Name:PSTR, S1ze:ULONG
	mov edx,Info
	mov eax,$Name
	mov ecx,S1ze
	.if (Ecx > 6) && W[Eax] == 'wZ'
		add PARSEINFO.S1ze[edx],ecx
		inc PARSEINFO.N[edx]
		inc PARSEINFO.S1ze[edx]	; EOL
	.endif
	xor eax,eax
	ret
ZwParseCallbackI endp

; +
;
;   .
;
GenerateZwList proc uses ebx esi edi
Local ImageHeader:PIMAGE_NT_HEADERS
Local ExportDirectory:PIMAGE_EXPORT_DIRECTORY
Local NumberOfNames:ULONG
Local Info:PARSEINFO
Local pNtList:PVOID
	mov ebx,g_NtView
	mov Info.S1ze,0
	mov Info.N,0
	invoke LdrImageQueryEntryFromHash, Ebx, addr Info, offset ZwParseCallbackI, addr Info, NULL	;   .
	mov ecx,Info.N
	shl ecx,4	; NTID.Name = 8
	add Info.S1ze,ecx
	invoke ZwAllocateVirtualMemory, NtCurrentProcess, addr g_NtList, 0, addr Info.S1ze, MEM_COMMIT, PAGE_READWRITE
	mov ecx,g_NtList
	test eax,eax
	mov pNtList,ecx
	jnz Exit
	invoke LdrImageNtHeader, Ebx, addr ImageHeader
	test eax,eax
	mov ecx,ImageHeader
	jnz Exit
	assume ecx:PIMAGE_NT_HEADERS
	mov eax,[ecx].OptionalHeader.DataDirectory.VirtualAddress
	test eax,eax
	jz Error
	add eax,ebx
	assume eax:PIMAGE_EXPORT_DIRECTORY	
	mov ExportDirectory,eax
	mov esi,[eax].AddressOfNames
	test esi,esi
	mov eax,[eax].NumberOfNames
	jz Error
	test eax,eax
	mov NumberOfNames,eax
	jz Error
	add esi,ebx
	xor edi,edi
	cld
Next:
	push esi
	push edi
	mov edx,D[esi]
	mov ecx,MAX_PATH
	add edx,ebx
	mov edi,edx
	xor eax,eax
	repne scasb
	not ecx
	add ecx,MAX_PATH
	.if (Ecx > 6) && W[Edx] == 'wZ'
		mov edi,pNtList
		mov NTID.S1ze[edi],ecx
		push ecx
		add edi,NTID.Nam3
		inc ecx
		mov esi,edx
		push edi
		rep movsb
		push 0
		Call LdrCalculateHash
		mov ecx,pNtList
		mov edx,D[esp]
		mov NTID.Hash[ecx],eax
		mov ecx,ExportDirectory
		assume ecx:PIMAGE_EXPORT_DIRECTORY
		mov eax,[ecx].AddressOfNameOrdinals
		add eax,ebx
		movzx edx,W[2*edx + eax]
		.if Edi
			.if Edx >= [Ecx]._Base
				sub edx,[ecx]._Base
			.endif
			inc edx
		.endif
		mov esi,[ecx].AddressOfFunctions
		add esi,ebx
		mov ecx,D[4*edx + esi]
		mov edx,pNtList
		mov NTID.Rva[edx],ecx
		mov pNtList,edi
		add ecx,ebx
		cmp B[ecx],0B8H	; mov eax,Id
		mov eax,D[ecx + 1]
		jne Error
		mov NTID.Id[edx],eax
	.endif
	pop edi
	pop esi
	inc edi
	add esi,4
	dec NumberOfNames
	jnz Next
	mov ecx,pNtList
	xor eax,eax
	mov g_NtListN,ecx
Exit:
	ret
Error:
	mov eax,STATUS_UNSUCCESSFUL
	jmp Exit
GenerateZwList endp

; +
;
;    ID.
;
FltIdToNTID proc uses ebx Id:ULONG
	cmp g_Init,FALSE
	je Fail
	mov eax,g_NtList
	mov ecx,g_NtListN
	mov ebx,Id
@@:
	mov edx,NTID.S1ze[eax]
	cmp NTID.Id[eax],ebx
	je Exit
	lea eax,[eax + edx + NTID.Nam3 + 1]
	cmp eax,ecx
	jb @b
Fail:
	xor eax,eax
Exit:
	ret
FltIdToNTID endp

; +
;
;     .
;
FltHashToNTID proc uses ebx Hash:ULONG
	cmp g_Init,FALSE
	je Fail
	mov eax,g_NtList
	mov ecx,g_NtListN
	mov ebx,Hash
@@:
	mov edx,NTID.S1ze[eax]
	cmp NTID.Hash[eax],ebx
	je Exit
	lea eax,[eax + edx + NTID.Nam3 + 1]
	cmp eax,ecx
	jb @b
Fail:
	xor eax,eax
Exit:
	ret
FltHashToNTID endp

; +
;
;    .
;
FltNameToNTID proc uses esi edi Nam3:PSTR
	cmp g_Init,FALSE
	je Fail
	cld
	mov eax,g_NtList
@@:
	mov esi,Nam3
	mov ecx,NTID.S1ze[eax]
	lea edi,NTID.Nam3[eax]
	inc ecx
	mov edx,NTID.S1ze[eax]
	repe cmpsb
	je Exit
	lea eax,[eax + edx + NTID.Nam3 + 1]
	cmp g_NtListN,eax
	jnb @b
Fail:
	xor eax,eax
Exit:
	ret
FltNameToNTID endp

; +
;
Unprotect proc Ip:PVOID, S1ze:ULONG, Protect
	invoke ZwProtectVirtualMemory, NtCurrentProcess, addr Ip, addr S1ze, Protect, addr Protect
	ret
Unprotect endp

; +
;
CreateLog proc
Local NameU:UNICODE_STRING
Local ObjAttr:OBJECT_ATTRIBUTES
Local IoStatus:IO_STATUS_BLOCK
	invoke RtlCreateUnicodeStringFromAsciiz, addr NameU, addr $Log
	lea eax,NameU
	mov ObjAttr.uLength,sizeof(OBJECT_ATTRIBUTES)
	mov ObjAttr.uAttributes,OBJ_CASE_INSENSITIVE
	mov ObjAttr.hRootDirectory,NULL
	mov ObjAttr.pObjectName,eax
	mov ObjAttr.pSecurityDescriptor,NULL
	mov ObjAttr.pSecurityQualityOfService,NULL
	invoke ZwCreateFile, addr g_File, 40100080H, addr ObjAttr, addr IoStatus, NULL, 80H, 1, 5, 60H, NULL, 0
	push eax
	invoke RtlFreeUnicodeString, addr NameU
	pop eax
	ret
CreateLog endp

; +
;
WriteLog proc Msg:PSTR, MsgLen:ULONG
Local Io:IO_STATUS_BLOCK
		invoke ZwWriteFile, g_File, NULL, NULL, NULL, addr Io, Msg, MsgLen, 0, NULL
		ret
WriteLog endp

OP_JMP_NEAR	equ 0E9H

Int3 macro
	BYTE 0CCH
endm

BREAKPOINT_PRINT	equ 1

; +
;  DebugService().
;
DebugService proc uses ebx esi edi ServiceClass:ULONG, Arg1:DWORD, Arg2:DWORD, Arg3:DWORD, Arg4:DWORD
	mov eax,ServiceClass
	mov ecx,Arg1
	mov edx,Arg2
	mov ebx,Arg3
	mov edi,Arg4
; Arguments:
;	Eax - BREAKPOINT_PRINT
;	Ecx - PSTR
;	Edx - STRLEN()
	pushad
	.if (Eax == BREAKPOINT_PRINT) && g_File
		invoke WriteLog, Ecx, Edx
	.endif
	popad
	Int 2DH
	Int3
	ret
DebugService endp

; +
;  DebugService().
;
DebugServicePatch proc uses esi edi
Local Header:PIMAGE_NT_HEADERS
	invoke LdrGetNtBase
	mov esi,eax
	invoke LdrImageNtHeader, Esi, addr Header
	mov eax,Header
	movzx edi,IMAGE_NT_HEADERS.FileHeader.SizeOfOptionalHeader[eax]
	add esi,IMAGE_SECTION_HEADER.VirtualAddress[eax + edi + IMAGE_NT_HEADERS.OptionalHeader]
	mov edi,IMAGE_SECTION_HEADER.VirtualSize[eax + edi + IMAGE_NT_HEADERS.OptionalHeader]
	.repeat
		.if D[Esi] == 5BCC2DCDH	; Int 0x2D/Int3/pop ebx
			.if D[Esi - 4] == 187D8B14H
				.if D[Esi - 1EH] == 90909090H
					.if D[Esi - 1AH] == 55FF8B90H
						sub esi,1EH
						invoke Unprotect, Esi, 7, PAGE_EXECUTE_READWRITE
						mov eax,offset DebugService
						mov B[esi],OP_JMP_NEAR
						sub eax,esi
						sub eax,5
						mov D[esi + 1],eax
						mov W[esi + 5],0F9EBH
						invoke Unprotect, Esi, 7, PAGE_EXECUTE_READ
						xor eax,eax
						jmp Exit
					.endif
				.endif
			.endif
		.endif
		inc esi
		dec edi
	.until Zero?
	mov eax,STATUS_NOT_FOUND
Exit:
	ret
DebugServicePatch endp

; +
;
ValidateMessageW proc uses edi MsgW:PWSTR
Local Mm:MEMORY_BASIC_INFORMATION
	invoke ZwQueryVirtualMemory, NtCurrentProcess, MsgW, MemoryBasicInformation, addr Mm, sizeof(MEMORY_BASIC_INFORMATION), NULL
	.if !Eax
		test Mm.State,MEM_COMMIT
		.if !Zero?
			test Mm.Protect,PAGE_READONLY or PAGE_READWRITE or PAGE_EXECUTE_READ or PAGE_EXECUTE_READWRITE
			.if !Zero?
				mov ecx,Mm.RegionSize
				mov edi,MsgW
				cld
				sub ecx,edi
				xor eax,eax
				add ecx,Mm.BaseAddress
				shr ecx,1
				repne scasw	; EOL
				.if Zero?
					sub edi,MsgW
					.if Edi < 256
						invoke RtlIsTextUnicode, MsgW, Edi, NULL
						.if Al
							mov ecx,edi
							mov ax,"%"
							shr ecx,1
							mov edi,MsgW
							repne scasw
							jne Exit
						.endif
					.endif
				.endif
			.endif
		.endif
	.endif
	xor eax,eax
Exit:
	ret		
ValidateMessageW endp

; +
;    .
;
IsProtectedProcess proc CID:PCLIENT_ID
Local ObjAttr:OBJECT_ATTRIBUTES, ProcessHandle:HANDLE
Local Buffer[MAX_PATH]:WCHAR
Local S1ze:ULONG
Local NameU1:UNICODE_STRING
Local NameU2:UNICODE_STRING
	xor eax,eax
	mov ObjAttr.uLength,sizeof OBJECT_ATTRIBUTES
	mov ObjAttr.hRootDirectory,eax
	mov ObjAttr.pObjectName,eax
	mov ObjAttr.uAttributes,eax
	mov ObjAttr.pSecurityDescriptor,eax
	mov ObjAttr.pSecurityQualityOfService,eax
	mov ProcessHandle,eax
	invoke ZwOpenProcess, addr ProcessHandle, PROCESS_QUERY_INFORMATION, addr ObjAttr, CID
	.if !Eax
		invoke ZwQueryInformationProcess, ProcessHandle, ProcessImageFileName, addr Buffer, MAX_PATH*2, addr S1ze
		mov ecx,S1ze
		.if !Eax
			shr ecx,1
			lea eax,Buffer
			.repeat
				.if W[Eax + Ecx*2 - 2] == "\"
					lea eax,[eax + ecx*2]
					invoke RtlInitUnicodeString, addr NameU1, Eax
					invoke RtlCreateUnicodeStringFromAsciiz, addr NameU2, addr $Olly
					invoke RtlCompareUnicodeString, addr NameU1, addr NameU2, TRUE
					push eax
					invoke RtlFreeUnicodeString, addr NameU2
					pop eax
					test eax,eax
					jnz Fail
					mov eax,TRUE
					jmp Exit
				.endif
				dec ecx
			.until Zero?
		.endif
	.endif
Fail:
	xor eax,eax
Exit:
	.if ProcessHandle
		push eax
		invoke ZwClose, ProcessHandle
		pop eax
	.endif
	ret
IsProtectedProcess endp

CPU_FAMILY	equ 111100000000B
CPU_MODEL		equ 000011110000B
CPU_STEPPING	equ 000000001111B

; +
;   SEP.
;
IsFastSystemCallEnable proc uses ebx esi
	xor esi,esi
	inc esi
	mov eax,esi
	cpuid
	bt edx,11	; SEP
	mov ecx,eax
	mov edx,eax
	.if Carry?
		and eax,CPU_FAMILY
		and ecx,CPU_MODEL
		and edx,CPU_STEPPING
		.if (Eax == (6 shl 8)) && (Cl < 3) && (Dl < 3)
			dec esi
		.endif
	.else
		dec esi
	.endif
	mov eax,esi
	ret
IsFastSystemCallEnable endp

STACK_FRAME struct
Next		PVOID ?	; PSTACK_FRAME
Ip		PVOID ?
STACK_FRAME ends
PSTACK_FRAME typedef ptr STACK_FRAME

PcStackBase	equ 4
PcStackLimit	equ 8

; +
;  .
;
IsCaller proc uses ebx esi edi Snap:PFLOW_ENTRY
	mov esi,ebp
	assume esi:PSTACK_FRAME
Scan:
	cmp fs:[PcStackBase],esi
	mov ebx,Snap
	jna Fail
	cmp fs:[PcStackLimit],esi
	ja Fail
	test ebx,ebx
	mov edi,[esi].Ip
	.if Zero?
Fail:	
		xor eax,eax
		jmp Exit
	.endif
	assume ebx:PFLOW_ENTRY
	.repeat
		mov eax,[Ebx].Ip
		add eax,[ebx].S1ze
		.if (Edi >= [Ebx].Ip) && (Edi < Eax)
			mov eax,esi
Exit:
			test eax,eax
			ret
		.endif
		add ebx,sizeof(FLOW_ENTRY)
	.until ![Ebx].Ip
	mov esi,[esi].Next
	jmp Scan
IsCaller endp

PEB_DBG_FLAG	equ X86_PAGE_SIZE - 4
TEB_DBG_FLAG	equ X86_PAGE_SIZE - 4

%TSTART macro
	mov D fs:[TEB_DBG_FLAG],FALSE
endm

%TSTOP macro
	mov D fs:[TEB_DBG_FLAG],TRUE
endm

FSTATE struct
	Ip	PVOID ?
	Args	PVOID ?
FSTATE ends
PFSTATE typedef ptr FSTATE

HASH_ZwQueryInformationProcess	equ 034DF9700H
HASH_ZwTerminateProcess			equ 0ED209DAEH
HASH_ZwClose					equ 0DE02B845H
HASH_ZwOpenProcess				equ 0FBA7C19BH
HASH_ZwSetInformationThread		equ 0857CB89BH
HASH_ZwCreateFile				equ 04AEBF61EH
HASH_ZwSetDebugFilterState		equ 07EB3AE99H
HASH_ZwContinue				equ 0A536E886H
HASH_ZwQueryPerformanceCounter	equ 0E3F0C117H
HASH_ZwQuerySystemInformation		equ 07085AB5AH

_ZwQueryInformationProcess struct
ProcessHandle			HANDLE ?
ProcessInformationClass	ULONG ?
ProcessInformation		PVOID ?
ProcessInformationLength	ULONG ?
ReturnLength			PULONG ?
_ZwQueryInformationProcess ends

ProcessDebugObjectHandle	equ 30
STATUS_PORT_NOT_SET		equ 0C0000353H

_ZwTerminateProcess struct
ProcessHandle			HANDLE ?
ExitStatus			NTSTATUS ?
_ZwTerminateProcess ends

_ZwClose struct
ObjectHandle			HANDLE ?
_ZwClose ends

OBJECT_HANDLE_FLAG_INFORMATION struct
Inherit				BOOL ?
ProtectFromClose		BOOL ?
OBJECT_HANDLE_FLAG_INFORMATION ends
POBJECT_HANDLE_FLAG_INFORMATION typedef ptr OBJECT_HANDLE_FLAG_INFORMATION

_ZwOpenProcess struct
ProcessHandle			HANDLE ?
DesiredAccess			ACCESS_MASK ?
ObjectAttributes		POBJECT_ATTRIBUTES ?
ClientId				PCLIENT_ID ?
_ZwOpenProcess ends

_ZwSetInformationThread struct
ThreadHandle			HANDLE ?
ThreadInformationClass	ULONG ?
ThreadInformation		PVOID ?
ThreadInformationLength	ULONG ?
_ZwSetInformationThread ends

CsrGetProcessId proto

_ZwCreateFile struct
FileHandle			PHANDLE ?
DesiredAccess			ACCESS_MASK ?
ObjectAttributes		POBJECT_ATTRIBUTES ?
IoStatusBlock			PIO_STATUS_BLOCK ?
AllocationSize			PLARGE_INTEGER ?
FileAttributes			ULONG ?
ShareAccess			ULONG ?
CreateDisposition		ULONG ?
CreateOptions			ULONG ?
EaBuffer				PVOID ?
EaLength				ULONG ?
_ZwCreateFile ends

_ZwSetDebugFilterState struct
ComponentId			ULONG ?
Level				ULONG ?
State				BOOLEAN ?
_ZwSetDebugFilterState ends

_ZwContinue struct
Context				PCONTEXT ?
TestAlert				BOOLEAN ?
_ZwContinue ends

_ZwQueryPerformanceCounter struct
PerformanceCounter		PLARGE_INTEGER ?
PerformanceFrequency	PLARGE_INTEGER ?
_ZwQueryPerformanceCounter ends

_ZwQuerySystemInformation struct
SystemInformationClass	ULONG ?
SystemInformation		PVOID ?
SystemInformationLength	ULONG ?
ReturnLength			PULONG ?
_ZwQuerySystemInformation  ends

.data
; http://pferrie.host22.com/papers/antidebug.pdf

$Sys \
 db "\??\EXTREM", 0		;Phant0m 
 db "\??\FILEM", 0		;FileMon 
 db "\??\FILEVXG", 0	;FileMon 
 db "\??\ICEEXT", 0		;SoftICE Extender 
 db "\??\NDBGMSG.VXD", 0	;SoftICE 
 db "\??\NTICE", 0		;SoftICE 
 db "\??\REGSYS", 0		;RegMon 
 db "\??\REGVXG", 0		;RegMon 
 db "\??\RING0", 0		;Olly Advanced 
 db "\??\SICE", 0		;SoftICE 
 db "\??\SIWVID", 0		;SoftICE 
 db "\??\TRW", 0		;TRW 
 db "\??\SPCOMMAND", 0	;Syser 
 db "\??\SYSER", 0		;Syser 
 db "\??\SYSERBOOT", 0	;Syser
 db "\??\SYSERDBGMSG", 0	;Syser
 db "\??\SYSERLANGUAGE", 0 ;Syser
 db 0
 
SysU \
	UNICODE_STRING 18 DUP (<>)
	
.code
; +
; 
IsProtectedDevice proc uses ebx NameU:PUNICODE_STRING
	lea ebx,SysU
	.repeat
		invoke RtlCompareUnicodeString, NameU, Ebx, TRUE
		.if Zero?
			mov eax,TRUE
			jmp Exit
		.endif
		add ebx,sizeof(UNICODE_STRING)
	.until !UNICODE_STRING.Buffer
	xor eax,eax
Exit:
	ret
IsProtectedDevice endp

; +
;  .
;
; Eax: ID
;
; [Esp]:
;	FSTATE
;	~Zw()
;	~Call Zw()
;	Arg1
;	...
;	ArgN
;
comment '
 -   (%EXIT_ALL) -
 
   IRET-:

[rEsp]:
	Eip
	rCs
	rEFlags
	rEsp
	rSs

KiServiceExit():

	mov edx,[esp]+TsExceptionList
	...
	mov ecx,[esp]+TsPreviousPreviousMode
	...

_KiSystemCallExit:
	iretd

_KiSystemCallExit2:
	test D[esp + 8],EFLAGS_TF	; rEFlags
	jnz _KiSystemCallExit		; TF
	pop edx					; rEip
	add esp,4					; rCs: IA32_SYSENTER_CS
	and D[esp],NOT EFLAGS_INTERRUPT_MASK
	popfd
	pop ecx					; rEsp
	sti						; STI      .
	sysexit					;   .


       (  Session Manager\Kernel\FastSystemCallDisable),   
   ,         .    
 .	 
'
SDISP	equ 8*4 + 2*4	; pushad/pushfd/push X

PUBLIC SysGate

Filter proc C
	ifndef OPT_ENABLE_DBG
		mov ecx,fs:[TEB.Peb]
		mov PEB.BeingDebugged[ecx],FALSE
	endif
	push STATUS_SUCCESS	;    rEax.
	pushfd
	pushad	; x8
	%TSTOP
	cmp eax,1000H
	mov ebx,FSTATE.Args[esp + SDISP]
	jnb Shadow
	invoke FltIdToNTID, Eax	;     .
	assume eax:PNTID
	.if Eax
		.if [Eax].Hash == HASH_ZwQueryInformationProcess
			;  NtQueryInformationProcess,   .
			assume ebx:ptr _ZwQueryInformationProcess
			.if ([Ebx].ProcessHandle == NtCurrentProcess)
				.if [Ebx].ProcessInformationClass == ProcessDebugObjectHandle
					mov eax,STATUS_PORT_NOT_SET
					jmp Fleave
				.elseif [Ebx].ProcessInformationClass == ProcessDebugPort
					mov ecx,[ebx].ProcessInformation
					mov eax,[ebx].ReturnLength
					mov D[ecx],NULL
					mov D[eax],sizeof(HANDLE)
					jmp Fleave2
				.elseif [Ebx].ProcessInformationClass == ProcessBasicInformation	; InheritedFromUniqueProcessId
					ifndef OPT_ENABLE_USER
						invoke CsrGetProcessId
					else
						invoke GetShellWindow
						.if !Eax
							invoke CsrGetProcessId
						.else
							push eax
							invoke GetWindowThreadProcessId, Eax, Esp
							test eax,eax
							pop eax
							.if Zero?
								invoke CsrGetProcessId
							.endif
						.endif
					endif
					push eax
					invoke ZwQueryInformationProcess, [Ebx].ProcessHandle, [Ebx].ProcessInformationClass, [Ebx].ProcessInformation, \
						[Ebx].ProcessInformationLength, [Ebx].ReturnLength
					test eax,eax
					pop ecx
					mov edx,[ebx].ProcessInformation
					jnz Fleave
					mov PROCESS_BASIC_INFORMATION.InheritedFromUniqueProcessId[edx],ecx
					jmp Fleave2
				.endif
			.endif
		.elseif [Eax].Hash == HASH_ZwTerminateProcess
			assume ebx:ptr _ZwTerminateProcess
			.if [Ebx].ProcessHandle != NtCurrentProcess
				jmp Fleave2
			.endif
		.elseif [Eax].Hash == HASH_ZwClose
			assume ebx:ptr _ZwClose
			;    .  ,  ,  .
			;    %TSTOP,    .
			sub esp,((sizeof OBJECT_HANDLE_FLAG_INFORMATION) and NOT(11B)) + sizeof(DWORD)
			mov edx,esp
			invoke ZwQueryObject, [Ebx].ObjectHandle, ObjectHandleInformation, Edx, sizeof(OBJECT_HANDLE_FLAG_INFORMATION), NULL
			add esp,((sizeof OBJECT_HANDLE_FLAG_INFORMATION) and NOT(11B)) + sizeof(DWORD)
			.if Eax == STATUS_INVALID_HANDLE
				jmp Fleave
			.endif
		.elseif [Eax].Hash == HASH_ZwOpenProcess
			assume ebx:ptr _ZwOpenProcess
			invoke IsProtectedProcess, [Ebx].ClientId
			.if Eax
				mov eax,STATUS_PROCESS_IS_TERMINATING
				jmp Fleave
			.endif
			invoke CsrGetProcessId
			mov ecx,[ebx].ClientId
			.if CLIENT_ID.UniqueProcess[Ecx] == Eax	; Debug priv.
				mov eax,STATUS_ACCESS_DENIED
				jmp Fleave2
			.endif
		.elseif [Eax].Hash == HASH_ZwSetInformationThread
			assume ebx:ptr _ZwSetInformationThread
			.if [Ebx].ThreadInformationClass == ThreadHideFromDebugger
				jmp Fleave2
			.endif
		.elseif [Eax].Hash == HASH_ZwCreateFile
			assume ebx:ptr _ZwCreateFile
			mov eax,[ebx].ObjectAttributes
			invoke IsProtectedDevice, OBJECT_ATTRIBUTES.pObjectName[eax]	; PUNICODE_STRING
			.if Eax
				mov eax,STATUS_OBJECT_NAME_NOT_FOUND
				jmp Fleave
			.endif
		.elseif [Eax].Hash == HASH_ZwSetDebugFilterState
			assume ebx:ptr _ZwSetDebugFilterState
			mov eax,STATUS_ACCESS_DENIED
			jmp Fleave
		.elseif [Eax].Hash == HASH_ZwContinue	;  TF.
			assume ebx:ptr _ZwContinue
			mov eax,D[esp + 8*4]	; EFlags
			mov ecx,[ebx].Context
			and eax,EFLAGS_TF
			or CONTEXT.rEFlags[ecx],eax
		.elseif [Eax].Hash == HASH_ZwQueryPerformanceCounter
			assume ebx:ptr _ZwQueryPerformanceCounter
			invoke ZwQueryPerformanceCounter, [Ebx].PerformanceCounter, [Ebx].PerformanceFrequency
			rdtsc
			and eax,111B	; Rand [1 % 8]
			inc eax
			add D[g_TSC],eax
			adc D[g_TSC + 4],0
			mov eax,[ebx].PerformanceCounter
			mov ecx,D[g_TSC]
			mov edx,D[g_TSC + 4]
			mov D[eax],ecx
			mov D[eax + 4],edx
			jmp Fleave2
		.elseif [Eax].Hash == HASH_ZwQuerySystemInformation
			assume ebx:ptr _ZwQuerySystemInformation
			.if ([Ebx].SystemInformationClass == SystemKernelDebuggerInformation) && \
				([Ebx].SystemInformationLength == sizeof(SYSTEM_KERNEL_DEBUGGER_INFORMATION))
				mov ecx,[ebx].SystemInformation
				mov edx,[ebx].ReturnLength
				.if Ecx
					mov SYSTEM_KERNEL_DEBUGGER_INFORMATION.DebuggerEnabled[ecx],FALSE
					mov SYSTEM_KERNEL_DEBUGGER_INFORMATION.DebuggerNotPresent[ecx],TRUE
					mov D[edx],sizeof(SYSTEM_KERNEL_DEBUGGER_INFORMATION)
					jmp Fleave2
				.endif
			.endif
		.endif
	.endif
Fenter:
;        .
; rEax: ID, [rEsp]: FSTATE
	;  S-   (  
	; TF     SysGate(),       ).
	ifdef OPT_ENABLE_SEP
		invoke TlsAdd
		lea ecx,SysGate
		xchg FSTATE.Ip[esp + SDISP],ecx
		mov TLS_ENTRY.Gate[eax],ecx
	endif
	popad
	popfd
	mov edx,0BADC0DEH
	lea esp,[esp + 4]
	%TSTART
	Int 2EH
Fleave:
;     UM( ).
; rEax: NTSTATUS
	mov D[esp + 8*4 + 4],eax	; NTSTATUS
Fleave2:
	popad
	popfd
	pop eax
	%TSTART
	lea ecx,[esp + sizeof(FSTATE)]
	mov edx,FSTATE.Ip[esp]
	retn 4
SysGate::
	push eax
	invoke TlsGet
	mov edx,TLS_ENTRY.Gate[eax]
	pop eax
	mov ecx,esp
	jmp Edx
Shadow:
;  .
	invoke TlsAdd
	mov ebx,eax
	invoke IsCaller, g_S_FindWindowA
	.if Eax
		lea ecx,xFindWindowA
		xchg STACK_FRAME.Ip[eax],ecx
		mov TLS_ENTRY.Ip[ebx],ecx
	.endif
	jmp Fenter
Filter endp

$Win \
 db "OLLYDBG", 0 
 db "WinDbgFrameClass", 0	;WinDbg 
 db "ID", 0				;Immunity Debugger 
 db "Zeta Debugger", 0 
 db "Rock Debugger", 0 
 db "ObsidianGUI", 0 
 db 0 
    
_FindWindow struct
lpClassName		PSTR ?
lpWindowName		PSTR ?
_FindWindow ends

; +
;
strcomp proc S1:PSTR, S2:PSTR
	mov ecx,S1
	mov edx,S2
	.repeat
		mov al,B[ecx]
		xor al,B[edx]
		and al,NOT(32)
		.if !Zero?
			mov eax,ecx
Exit:
			ret
		.endif
		inc ecx
		inc edx
	.until (!B[Ecx]) || (!B[Edx])
	xor eax,eax
	jmp Exit
strcomp endp

; +
;
xFindWindowA proc C
	push ebx
	push esi
	push edi
	push eax
	lea ebx,[esp + sizeof(STACK_FRAME) + 4*4]
	assume ebx:ptr _FindWindow
	mov esi,[ebx].lpClassName
	lea edi,$Win
	.if Esi
		.repeat
			invoke strcomp, Esi, Edi
			.if !Eax
				pop ecx	; rEax
				jmp Exit
			.endif
			cld
			xor eax,eax
			mov ecx,esi
			repne scasb
		.until !B[Edi]
	.endif
	pop eax
Exit:
	pop edi
	pop esi
	pop ebx
	push eax
	invoke TlsGet
	mov ecx,TLS_ENTRY.Ip[eax]
	pop eax
	jmp Ecx
xFindWindowA endp

	include Avrf.inc
	
xApi proc C
	jmp RTL_VERIFIER_THUNK_DESCRIPTOR.ThunkOldAddress[Dll1Thunks]
xApi endp

.data
$Tnunk1	CHAR "MessageBoxTimeoutW",0
$DLL1	WCHAR "U","s","e","r","3","2",".","d","l","l",0

align 4

; RTL_VERIFIER_THUNK_DESCRIPTOR{}
Dll1Thunks	dd $Tnunk1
			dd 0
			dd xApi

			dd 0	; EOL

; RTL_VERIFIER_DLL_DESCRIPTOR{}
DLL1			dd $DLL1
			dd 0
			dd 0
			dd Dll1Thunks
			
			dd 0	; EOL

; RTL_VERIFIER_PROVIDER_DESCRIPTOR{}
Avrf			dd sizeof(RTL_VERIFIER_PROVIDER_DESCRIPTOR)
			dd DLL1
			dd 0
			dd 0
			dd 0
			dd 0
.code
; +
;
Stop proc
Local Response:ULONG
	invoke ZwRaiseHardError, STATUS_SUCCESS, 1, 0, 0, OptionOkCancel, addr Response
Stop endp

; +
;
InitSys proc uses ebx edi
	lea edi,$Sys
	lea ebx,SysU
	.repeat
		invoke RtlCreateUnicodeStringFromAsciiz, Ebx, Edi
		cld
		xor eax,eax
		mov ecx,MAX_PATH
		repne scasb
		add ebx,sizeof(UNICODE_STRING)
	.until !B[Edi]
	ret
InitSys endp

; +
; 
LDE proc C
	xchg D[esp + 4],esi
	Call VirXasm32
	mov esi,D[esp + 4]
	retn 4
LDE endp

; +
;
AllocMemory proc S1ze:ULONG
Local Base:PVOID
	mov Base,NULL
	invoke ZwAllocateVirtualMemory, NtCurrentProcess, addr Base, 0, addr S1ze, MEM_COMMIT, PAGE_EXECUTE_READWRITE
	.if Eax
		xor eax,eax
	.else
		mov eax,Base
	.endif
	ret
AllocMemory endp

_imp__FindWindowA proto :PSTR, :PSTR
_imp__FindWindowW proto :PWSTR, :PWSTR

; +
;    FindWindow().
;	
FindWindowInitialize proc
;   NtUserFindWindowEx    .    ,      !NL.
	invoke AllocMemory, X86_PAGE_SIZE	; 512 Ip's
	.if Eax
		mov g_S_FindWindowA,eax
		invoke Snapshot, D[_imp__FindWindowA], g_S_FindWindowA, addr LDE, NULL, NULL
	.endif
	invoke AllocMemory, X86_PAGE_SIZE
	.if Eax
		mov g_S_FindWindowW,eax
		invoke Snapshot, D[_imp__FindWindowW], g_S_FindWindowW, addr LDE, NULL, NULL
	.endif
	ret
FindWindowInitialize endp

; +
; DLL
;
Startup proc uses ebx DllHandle:HANDLE, Reason:ULONG, Context:PVOID
	.if Reason == DLL_PROCESS_ATTACH
		invoke IsFastSystemCallEnable
		mov g_SEP,eax
		invoke LdrGetNtBase
		mov g_NtBase,eax
		invoke InitSys
		invoke FindWindowInitialize
		ifdef OPT_ENABLE_PRINT
			invoke DebugServicePatch
		endif
;		invoke CreateLog
		invoke LdrMapViewOfImage, g_NtBase, addr g_NtView
		mov ebx,fs:[TEB.Peb]
		test eax,eax
;		mov PEB.BeingDebugged[ebx],FALSE
		jl Exit
		invoke GenerateZwList
		.if !Eax
			mov g_Init,TRUE
			mov D[ebx + PEB_DBG_FLAG],offset Filter
			%TSTART
		.endif
	.elseif Reason == DLL_PROCESS_DETACH
		mov D[ebx + PEB_DBG_FLAG],NULL
	.elseif Reason == DLL_PROCESS_VERIFIER
		mov ecx,Context
		mov D[ecx],offset Avrf
	.endif
Exit:
	mov eax,TRUE
	ret
Startup Endp
;end Startup

DbgUiIssueRemoteBreakin proto :HANDLE

$Dll		CHAR "psapi.dll", 0
$Shell	CHAR "WinDbgFrameClass", 0

EP proc
Local Context:CONTEXT
Local Count:LARGE_INTEGER
	invoke Startup, NULL, DLL_PROCESS_ATTACH, NULL
	invoke FindWindowInitialize
	
	invoke FindWindow, addr $Shell, NULL
	
	invoke DbgUiIssueRemoteBreakin, NtCurrentProcess
	
	invoke LoadLibrary, addr $Dll
	
repeat 16
	invoke ZwQueryPerformanceCounter, addr Count, NULL
	%DBG "0x%X", D[Count]
endm

	ret
EP endp
end EP
end Startup